function Hq = hessian_phi(x, q, varargin)
%HESSIAN_PHI Add your code here for evaluating matrix vector products with the hessian of 
%function phi(x) at x.
%
% Input
%
% x:        The point on which the hessian of phi(x) has to be evaluated.
% q:        The vector to be multiplied with the hessian of phi(x) at x.
% varargin: Dynamic cell for handling extra arguments from the user, see 
%           http://www.mathworks.co.uk/help/matlab/ref/varargin.html for
%           details.
%
% Output
%
% Hq: The result of the matrix vector product of the hessian of phi(x) at x
% with q.

%% Example
% In this particular example phi(x) is the logistic regression function, 
% varargin{1} = X (the matrix of training samples) and varargin{2} = labels
% (the labels of the training samples.)

t      = 1./(1+exp(-varargin{2}.*(varargin{1}*x)));
Hq = varargin{1}'*(t.*(1-t).*(varargin{1}*q));

end