%DEMO_USER_STOP Demonstrates the usage of pdNCG solver for a user-defined
%stoppping criterion. The problem that is used for this demo is a
%least-squares problem:
%
%  min tau*||x||_1 + 0.5||Ax-b||_2^2.

clear;

% Load a problem (A,b,xopt,fvalOpt), where its optimal solution xopt is
% given for tau = 1.0.
load data_ls.mat

[~, n] = size(A);

% Options.
opts.problem = 'ls';
opts.n = n;
opts.tau = 1.0;

% Terminate solver when the rellative error of the solution drops below
% 0.1.
opts.user_stop = @(opts,primal,dual,f,g,H,d) ...
                   norm(primal - xopt)/norm(xopt) <= 1.0e-1;

opts.A = A;
opts.b = b;

% Call pdNCG.
[x, y, out] = pdNCGinterface(opts);

fprintf('Elapsed time: %d \n', out.time);

fprintf('Rellative error: %d \n', norm(x-xopt)/norm(xopt));

clear;